/* $Id: compliance.js,v 1.19 2008/01/17 11:26:29 hanifa Exp $ */

function loadDDPolicyData(policySelectVal,resourceId)
{
    if(policySelectVal == "All Policies")
    {
       policySelectVal = "ALL";
    }
    
    stateData["NCMDDCompTableView"]["_D_RP"]= "&COMPPOLICY_ID=" + policySelectVal + "&RESOURCEID=" + resourceId;
    refreshSubView('NCMDDCompTableView');
}


function showCriteriaType(criteriaType)
{
  var simpleRow = document.getElementById('simple_criteria_row');
  var advRow = document.getElementById('adv_criteria_row');
  
  if(criteriaType == 'simple')
  {
    simpleRow.className = '';
    advRow.className = 'hide';
  }
  else
  {
    simpleRow.className = 'hide';
    advRow.className = '';    
  }
}

function addAdvCriteriaToForm(addruleform,valcriteriaform)
{
   var rowCountEle = addruleform.ROWIDX;
   if(rowCountEle.length != undefined)
   {
     var noOfRows = rowCountEle.length;
     for(var i=0;i<noOfRows;i++)
     {
	var comparator = document.getElementById("COMPARATOR_" + rowCountEle[i].value).value;
	var condition = document.getElementById("CONDITION_" + rowCountEle[i].value).value;
	var pattern = document.getElementById("PATTERN_" + rowCountEle[i].value).value;
        addCriteriaToForm(comparator,condition,pattern,rowCountEle[i].value,valcriteriaform);
     }

     var newCompEle = document.createElement("input");
     newCompEle.setAttribute("type","hidden");
     newCompEle.setAttribute("name","ROWCOUNT");
     newCompEle.setAttribute("value",noOfRows);
     valcriteriaform.appendChild(newCompEle);
   }
   else
   {
     var comparator = document.getElementById("COMPARATOR_1").value;
     var condition = document.getElementById("CONDITION_1").value;
     var pattern = document.getElementById("PATTERN_1").value;
     addCriteriaToForm(comparator,condition,pattern,'1',valcriteriaform);
     
     var newCompEle = document.createElement("input");
     newCompEle.setAttribute("type","hidden");
     newCompEle.setAttribute("name","ROWCOUNT");
     newCompEle.setAttribute("value",'1');
     valcriteriaform.appendChild(newCompEle);
   }

}

function addCriteriaToForm(comparator,condition,pattern,count,form)
{
   var newCompEle = document.createElement("input");
   newCompEle.setAttribute("type","hidden");
   newCompEle.setAttribute("name","COMPARATOR_" + count);
   newCompEle.setAttribute("value",comparator);
   form.appendChild(newCompEle);

   var newConEle = document.createElement("input");
   newConEle.setAttribute("type","hidden");
   newConEle.setAttribute("name","CONDITION_" + count);
   newConEle.setAttribute("value",condition);
   form.appendChild(newConEle);

   var newPattEle = document.createElement("input");
   newPattEle.setAttribute("type","hidden");
   newPattEle.setAttribute("name","PATTERN_" + count);
   newPattEle.setAttribute("value",pattern);
   form.appendChild(newPattEle);
}


function getRulesForRuleGrp()
{
   var rgId = document.getElementById('RULEGROUP').value;
   var xmlhttp = AjaxAPI.getXMLHttpRequest();
   var url = "jsp/compliance/Import.jsp?COMPRULEGROUP_ID=" + rgId;
   
   xmlhttp.onreadystatechange = function(){
	if(xmlhttp.readyState == 4)
	{
	  if(xmlhttp.status == 200)
	  {
	     var result = xmlhttp.responseText;
	     //alert(result);
	     //result = trimAll(result);
	     //document.getElementById('loading_row').className='hide';

	     /*var lineArray = result.split('\n');
	     var len = lineArray.length;
	     var bodyText = "";
	     for(var j=0;j<len;j++)
	     {
	       bodyText = bodyText + lineArray[j] + "<br>";
	     }*/
	  
	     closeDialog();	
	  }	
	}
      };
      
   xmlhttp.open("GET",url,true);      
   xmlhttp.send(null);   
}


function getRuleGrpsForPolicy()
{
   var policyId = document.getElementById('POLICYNAME').value;
   var xmlhttp = AjaxAPI.getXMLHttpRequest();
   var url = "jsp/compliance/Import.jsp?COMPPOLICY_ID=" + policyId;
   
   xmlhttp.onreadystatechange = function(){
	if(xmlhttp.readyState == 4)
	{
	  if(xmlhttp.status == 200)
	  {
	     var result = xmlhttp.responseText;
	     //alert(result);
	     //result = trimAll(result);
	     //document.getElementById('loading_row').className='hide';

	     /*var lineArray = result.split('\n');
	     var len = lineArray.length;
	     var bodyText = "";
	     for(var j=0;j<len;j++)
	     {
	       bodyText = bodyText + lineArray[j] + "<br>";
	     }*/
	  
	     closeDialog();	
	  }	
	}
      };
      
   xmlhttp.open("GET",url,true);      
   xmlhttp.send(null);   
}


function getSelectedRulesForAddRG(form,viewName)
{
   var tblModel = getTableModel(viewName);
   if(!tblModel.isAtleastOneChecked("Select a Rule"))
   {
   	return false;
   }
   
   var selIndices = tblModel.getSelectedRowIndices();
   var colInd = tblModel.getColumnIndex("COMPRULE_ID");
   
   var pkValueStr = "";
   for(var i=0;i<selIndices.length;i++)
   {
      pkValueStr = pkValueStr + "&" + "COMPRULE_ID" + "=" + tblModel.getValueAt(selIndices[i],colInd);
   }
 
   form.action = getURLSuffixed(form.action) + "?" + pkValueStr;
   return true;
      
}


function getSelectedRGsForAddPolicy(form,viewName)
{
   var tblModel = getTableModel(viewName);
   if(!tblModel.isAtleastOneChecked("Select a Rule Group"))
   {
   	return false;
   }
   
   var selIndices = tblModel.getSelectedRowIndices();
   var colInd = tblModel.getColumnIndex("COMPRULEGROUP_ID");
   
   var pkValueStr = "";
   for(var i=0;i<selIndices.length;i++)
   {
      pkValueStr = pkValueStr + "&" + "COMPRULEGROUP_ID" + "=" + tblModel.getValueAt(selIndices[i],colInd);
   }
   
   form.action = getURLSuffixed(form.action) + pkValueStr;
   return true;
      
}

function validateCompRuleCriteria(form)
{
  // validate simple criteria
  if(form.CRITERIA_TYPE[0].checked)
  {
    if(!isNotEmpty(form.SIMPLE_PATTERN.value))
    {
      alert("Enter the Pattern");
      return false;
    }
  }
  // validate advanced criteria
  else
  {
    return validateAdvCriteria(form);
  }
  
  return true;
  
}

function validateAdvCriteria(form)
{
   var rowCountEle = form.ROWIDX;
   if(rowCountEle.length != undefined)
   {
     var noOfRows = rowCountEle.length;
     for(var i=0;i<noOfRows;i++)
     {
	var pattern = document.getElementById("PATTERN_" + rowCountEle[i].value).value;
        if(!isNotEmpty(pattern))
        {
          alert("Enter the Pattern");
          return false;
        }
     }
   }
   else
   {
     var pattern = document.getElementById("PATTERN_1").value;
     if(!isNotEmpty(pattern))
     {
       alert("Enter the Pattern");
       return false;
     }
   }

   return true;
   
}

function validateAdhocTestDeviceLimit(form,testType)
{
  if(form.ComponentSelection[0].checked)
  {
        if(testType == 'POLICY' && form.SELECTEDDEVICES.length > 20)
        {
	   alert("A maximum of 20 devices can be tested at a time. Choose 20 or lesser devices");
	   return false;
        }
	else if(form.SELECTEDDEVICES.length > 50)
	{
	   alert("A maximum of 50 devices can be tested at a time. Choose 50 or lesser devices");
	   return false;
	}
  }
  else
  {
  	var selectedIndex = form.DEVICEGROUPSELECTION.selectedIndex;
  	var dgId = form.DEVICEGROUPSELECTION.options[selectedIndex].value;
  	
        var xmlhttp = AjaxAPI.getXMLHttpRequest();
        var url = "jsp/compliance/GetDGDeviceCount.jsp?DEVICE_GROUP_ID=" + dgId;
        xmlhttp.open("GET",url,false);      
        xmlhttp.send(null);
        deviceCount = new Number(trimAll(xmlhttp.responseText));
        if(testType == 'POLICY' && deviceCount > 20)
        {
          alert("A maximum of 20 devices can be tested at a time. This Device Group contains more than 20 devices");	     
	  return false;	     
        }
        else if(deviceCount > 50)
        {
          alert("A maximum of 50 devices can be tested at a time. This Device Group contains more than 50 devices");	     
	  return false;	     
        }
        else if(deviceCount == 0)
        {
          alert("This device group has no devices");	     
	  return false;	     
        }
  }
  
  return true;
  
}


function showRulesInRuleGroup(menuItemId, srcViewRefId, additionalParams,index)
{
    var tablemodel = getTableModel(srcViewRefId);
    var rgName = tablemodel.getValueAt(index,tablemodel.getColumnIndex("COMPRULEGROUP_NAME"));
    var title = 'Compliance Rules in ' + rgName;
    
    var menuItemObj = getMenuItemObj(menuItemId);
    showURLInDialog(menuItemObj.getActionURL(srcViewRefId,additionalParams,index),"position=absmiddle,title=" + title + ",modal=no,width=550,closePrevious=false");
}

function showAddCompRule(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    showURLInDialog(menuItemObj.getActionURL(srcViewRefId,additionalParams,index),"position=absmiddle,title=Compliance Rule Details,modal=no,width=750");
}

function showAddCompRuleGrp(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    removeStateForView('NCMAddRGRuleList');
    var url = updateStateCookieAndAppendSid(menuItemObj.getActionURL(srcViewRefId,additionalParams,index));
    showURLInDialog(url,"position=absmiddle,title=Compliance Rule Group Details,modal=no,width=750");
}

function showAddCompPolicy(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    removeStateForView('NCMAddPolicyRGList');
    var url = updateStateCookieAndAppendSid(menuItemObj.getActionURL(srcViewRefId,additionalParams,index));
    showURLInDialog(url,"position=absmiddle,title=Compliance Policy Details,modal=no,width=750");
}

function showAssociateDevices(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    showURLInDialog(menuItemObj.getActionURL(srcViewRefId,additionalParams,index),"position=absmiddle,title=Associate Devices & Device Groups,modal=no,width=750");
}

function showVersionDraftCompCheckInput(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    showURLInDialog(menuItemObj.getActionURL(srcViewRefId,additionalParams,index),"title=Compliance Check,closePrevious=false",null,srcViewRefId);
}


function changePolicySelectionType(selectionType)
{
  var assignedHeader = document.getElementById('assigned_header');
  var assignedList = document.getElementById('assigned_list');

  var selectionHeader = document.getElementById('selection_header');
  var selectionList = document.getElementById('selection_list');
  
  if(selectionType == 'ASSIGNED')
  {
    assignedHeader.className = '';
    assignedList.className = '';
    selectionHeader.className = 'hide';
    selectionList.className = 'hide';
  }
  else
  {
    assignedHeader.className = 'hide';
    assignedList.className = 'hide';
    selectionHeader.className = '';
    selectionList.className = '';
  }
}

