/* $Id: usermanagement.js,v 1.8 2008/01/17 11:26:29 hanifa Exp $ */
function validatePassword(value,formElement)
{
    if(!isNotEmpty(value,formElement))
    {
    	//alert("Enter a valid password");
	return false;
    }
    if(value.length < 5)
    {	
        //alert("Password should contain atleast 5 characters");
	return false;
    }
    if(value.length >20)
    {
        //alert("Password should be between 5-20 characters");
	return false;
    }
    return true;
}

function validatePassword1(value,formElement)
{
    if(!isNotEmpty(value,formElement))
    {
    	alert("Enter a valid password");
	return false;
    }
    if(value.length < 5)
    {	
        alert("Password should contain atleast 5 characters");
	return false;
    }
    if(value.length >20)
    {
        alert("Password should be between 5-20 characters");
	return false;
    }
    return true;
}

function validateNewPassword(value,formElement)
{
    if(!isNotEmpty(value, formElement))
    {
	return false;
    }
    if(value.length < 5)
    {
	return "Password should contain atleast 5 characters";
    }
    if(value.length >20)
    {
	return "Password should be between 5-20 characters";
    }
    return true;
}

function validateConfirmPassword3(value, formElement)
{
    if(!isNotEmpty(value, formElement))
    {
 	return false;
    }
    if(value != formElement.form.newPassword.value)
    {
 	return "Password mismatch";
    }
    return true;
}

function validateConfirmPassword2(obj,form)
{
    var value = obj.value;
    if(!isNotEmpty(value,obj))
    {
	alert("Enter the same password for Confirm Password");
	return false;
    }
    if(value != form.password.value)
    {
 	alert("Password mismatch");
 	return false;
    }
    return true;
}

function validUserName(obj)
{
     var str = obj.value;
     var str1 = trimAll(str);
     if(str1.length == 0)
     {
         alert('Enter a valid login name');
         return false;
     }
     
     if(isAlphaNumericDotDash(str,obj))
     {
         var result=isUniqueColoumn('AaaLogin','NAME',str);
         if(result != "true")
         {
             alert("Login Name already exists");
             return false;
         }
     }
     return true;
}

function isUniqueColoumn(tablename,colname,value)
{
   var xmlhttp = AjaxAPI.getXMLHttpRequest();
   var url = "jsp/xmlhttp/persistence.jsp?reqType=isunique&table="+tablename+"&col="+colname+"&colVal="+value;
   xmlhttp.open("GET",url,false);
   xmlhttp.send(null);
   var result = xmlhttp.responseText;
   result = trimAll(result);
   return result;
}

function validateUserCreation(form)
{
    if(createnewuser)
    {
        var loginName = form.loginName;
        if(!validUserName(loginName))
        {
            loginName.focus();
            return false; 
        }
    
        var password = form.password;
        if(!validatePassword1(password.value,password))
        {
            password.focus();
            return false; 
        }
  
        var confirmPass = form.confirmpass;
        if(!validateConfirmPassword2(confirmPass,form))
        {
            confirmPass.focus();
            return false; 
        }    
    }

    var emailId = form.emailaddress;
    if(!isEmailId(emailId.value))
    {
        alert('Enter a valid Email Address');
        emailId.focus();
        return false; 
    }
    
    if(form.roles.options[form.roles.selectedIndex].value != 'Administrator')
    {
        if(!deviceGroupChooserValidation(form))
        {
            return false;
        }
    }
    return true;
}