/* $Id: manualaddition.js,v 1.19 2008/01/17 11:26:28 hanifa Exp $ */

/*------------------------------- Common Script functions - Starts ------------------------------*/



function showAddDeivce(menuItemId, srcViewRefId, additionalParams,index)
{
   var menuItemObj = getMenuItemObj(menuItemId);
   var url =  menuItemObj.getActionURL(srcViewRefId,additionalParams,index);

   var params = 'title=Add Device';
   showURLInDialog(url,params);

}



function cleanOptionsInSelectBox(elementObj,addNONE)
{
//    var elementObj = eval(elementid);
    while(elementObj.length > 0)
    {
        for (var i=0;i<elementObj.length;i++)
        {
            elementObj.options[i] = null;
        }
    }
    
    if (addNONE)
    {
        elementObj.options[0] = new Option('NONE','NONE');
    }
}

/*------------------------------ Common Script functions - Ends ---------------------------------*/


// ********  Script for new inline AddDevice implementation ***************

function getDeviceTypeForVendor(form)
{   
    var xmlhttp = AjaxAPI.getXMLHttpRequest();
    var vendorName = form.VENDOR_NAME.value;
    var url = "jsp/manualaddition/FetchDeviceInfo.jsp?&ACTION=GET_DEVICETYPE&VENDOR_NAME="+vendorName;
    xmlhttp.open("GET",url,false);
    xmlhttp.send(null);

    var result = xmlhttp.responseText;
    result = trimAll(result);
    var deviceTypeField =  form.DEVICE_BEHAVIOUR;
    changeStatus(deviceTypeField,result);
}

function changeStatus(selectObj,result)
{
    var splitedResult = result.split(",");
    cleanOptionsInSelectBox(selectObj,true);
    for(var i=0;i<splitedResult.length;i++)
    {
        selectObj.options[i] = new Option(splitedResult[i], splitedResult[i]);
    }
}

function dnsResolved(form)
{
    var xmlhttp = AjaxAPI.getXMLHttpRequest();
    var ipaddress = form.IPADDRESS.value;
    if(!isNotEmpty(ipaddress))
    {
    return false;
    }
    var url = "jsp/manualaddition/FetchDeviceInfo.jsp?&ACTION=CHECK_DNSNAME&IPADDRESS="+ipaddress;
    xmlhttp.open("GET",url,false);
    xmlhttp.send(null);

    var result = xmlhttp.responseText;
    result = trimAll(result);
    if(result == "true")
    {
    return true;
    }
    else
    {
    return false;
    }
}

function showHideComponent(componentId, isShow)
{
        var showHideObjects = MM_findObj(componentId);
        if(isShow == true)
        {
                showHideObjects.className = '';
        }
        else
        {
                showHideObjects.className = 'hide';
        }

}

/*
function pingDevice(pingip)
{
	if(is_demo)
	{
		return demoAlert();
	}
      if(!isNotEmpty(pingip))
      {
          alert("Enter Host Name or IP address");
          return;
      }
      viewname = 'NCMPingView.c?IPADDRESS=' + pingip;
      var params = 'title=Ping Status,closePrevious=false';
      showURLInDialog(viewname,params);
}
*/
