/* $Id: showcommand.js,v 1.7 2008/01/17 11:26:29 hanifa Exp $ */
function executeCommand(resId,command,selectObj)
{
   var xmlhttp = AjaxAPI.getXMLHttpRequest();
   var url = "jsp/deviceprop/ExecuteShowCommand.jsp?RESOURCEID=" + resId + "&COMMAND="+command;
   
   xmlhttp.onreadystatechange = function(){
	if(xmlhttp.readyState == 4)
	{
	  if(xmlhttp.status == 200)
	  {
	     var result = xmlhttp.responseText;
	     //result = trimAll(result);
	     document.getElementById('loading_row').className='hide';

	     //var lineArray = result.split('\n');
	     //var len = lineArray.length;
	     //for(var j=0;j<len;j++)
	     //{
	     //  bodyText = bodyText + lineArray[j] + "<br>";
	     //}

	     var bodyText = "<div style='color:#1569B9;border-bottom:1px solid #D5D5D5;line-height:30px;font-weight:bold;padding-left:5px;'>Executed Command : " + command + "</div><div class='level_font' style='padding-left:5px;line-height:25px;'>";

	     bodyText = bodyText + result + "</div>";
	     document.getElementById('resultdiv').innerHTML = bodyText;//result;
	     selectObj.disabled = false;
	  }	
	}
      };
      
   xmlhttp.open("GET",url,true);      
   xmlhttp.send(null);   
}

function addShowCommand(menuItemId, srcViewRefId, additionalParams,index)
{
   var menuItemObj = getMenuItemObj(menuItemId);
   var url =  menuItemObj.getActionURL(srcViewRefId,additionalParams,index);

   var params = 'position=absmiddle,height=150,width=350,title=Add New Command'; 
   showURLInDialog(url,params);
   
}

function editShowCommand(menuItemId, srcViewRefId, additionalParams,index)
{
   var menuItemObj = getMenuItemObj(menuItemId);
   var url =  menuItemObj.getActionURL(srcViewRefId,additionalParams,index);

   var tablemodel = getTableModel(srcViewRefId);
   var commandId = tablemodel.getValueAt(index,tablemodel.getColumnIndex("COMMAND_ID"));
   var commandAlias = tablemodel.getValueAt(index,tablemodel.getColumnIndex("COMMAND_ALIAS"));   
   var showCommand = tablemodel.getValueAt(index,tablemodel.getColumnIndex("SHOW_COMMAND"));
   var vendor = tablemodel.getValueAt(index,tablemodel.getColumnIndex("VENDORNAME"));
   url = url + "&COMMAND_ID=" + commandId + "&ALIAS=" + commandAlias + "&COMMAND=" + showCommand + "&VENDOR=" + vendor;

   var params = 'position=absmiddle,height=150,width=350,title=Edit Command'; 
   showURLInDialog(url,params);
   
}

function displayShowCommandsView(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    showURLInDialog(menuItemObj.getActionURL(srcViewRefId,additionalParams,index),"position=absmiddle,title=Execute Show Commands,modal=no,width=750");
}

function executeShowCommand(resourceId,selectObj,imagePath)
{
  var command = selectObj.options[selectObj.selectedIndex].value;
  if(command == '---- Show Command ----')
  {
    //alert('Please choose the command to execute');
    return;
  }
  
  selectObj.disabled = true;
  document.getElementById('resultdiv').innerHTML = '';
  document.getElementById('choose_message_div').className = 'hide';
  
  document.getElementById('loading_row').innerHTML = "<img src='" + imagePath + "/images/icon_csh_inprogress.gif'>&nbsp;<b><span style='font:Bold 15px Arial, Helvetica, sans-serif; color:#666666;'>Executing command - " + command + "</span></b>";
  document.getElementById('loading_row').className = '';
  
  executeCommand(resourceId,command,selectObj);
  
}